Option Strict Off
Option Explicit On
Friend Class MainForm
	Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
	Public Sub New()
		MyBase.New()
		If m_vb6FormDefInstance Is Nothing Then
			If m_InitializingDefInstance Then
				m_vb6FormDefInstance = Me
			Else
				Try 
					'For the start-up form, the first instance created is the default instance.
					If System.Reflection.Assembly.GetExecutingAssembly.EntryPoint.DeclaringType Is Me.GetType Then
						m_vb6FormDefInstance = Me
					End If
				Catch
				End Try
			End If
		End If
		'This call is required by the Windows Form Designer.
		InitializeComponent()
	End Sub
	'Form overrides dispose to clean up the component list.
	Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
		If Disposing Then
			If Not components Is Nothing Then
				components.Dispose()
			End If
		End If
		MyBase.Dispose(Disposing)
	End Sub
	'Required by the Windows Form Designer
	Private components As System.ComponentModel.IContainer
	Public ToolTip1 As System.Windows.Forms.ToolTip
	Public WithEvents ExitButton As System.Windows.Forms.Button
	Public WithEvents DrawingArea As System.Windows.Forms.PictureBox
	'NOTE: The following procedure is required by the Windows Form Designer
	'It can be modified using the Windows Form Designer.
	'Do not modify it using the code editor.
	<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
		Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(MainForm))
		Me.components = New System.ComponentModel.Container()
		Me.ToolTip1 = New System.Windows.Forms.ToolTip(components)
		Me.ToolTip1.Active = True
		Me.ExitButton = New System.Windows.Forms.Button
		Me.DrawingArea = New System.Windows.Forms.PictureBox
		Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
		Me.Text = "Area Tooltip"
		Me.ClientSize = New System.Drawing.Size(282, 153)
		Me.Location = New System.Drawing.Point(3, 22)
		Me.MaximizeBox = False
		Me.MinimizeBox = False
		Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
		Me.Font = New System.Drawing.Font("Arial", 8!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
		Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
		Me.BackColor = System.Drawing.SystemColors.Control
		Me.ControlBox = True
		Me.Enabled = True
		Me.KeyPreview = False
		Me.Cursor = System.Windows.Forms.Cursors.Default
		Me.RightToLeft = System.Windows.Forms.RightToLeft.No
		Me.ShowInTaskbar = True
		Me.HelpButton = False
		Me.WindowState = System.Windows.Forms.FormWindowState.Normal
		Me.Name = "MainForm"
		Me.ExitButton.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
		Me.CancelButton = Me.ExitButton
		Me.ExitButton.Text = "E&xit"
		Me.ExitButton.Size = New System.Drawing.Size(73, 25)
		Me.ExitButton.Location = New System.Drawing.Point(200, 120)
		Me.ExitButton.TabIndex = 1
		Me.ExitButton.Font = New System.Drawing.Font("Arial", 8!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
		Me.ExitButton.BackColor = System.Drawing.SystemColors.Control
		Me.ExitButton.CausesValidation = True
		Me.ExitButton.Enabled = True
		Me.ExitButton.ForeColor = System.Drawing.SystemColors.ControlText
		Me.ExitButton.Cursor = System.Windows.Forms.Cursors.Default
		Me.ExitButton.RightToLeft = System.Windows.Forms.RightToLeft.No
		Me.ExitButton.TabStop = True
		Me.ExitButton.Name = "ExitButton"
		Me.DrawingArea.Size = New System.Drawing.Size(185, 105)
		Me.DrawingArea.Location = New System.Drawing.Point(8, 8)
		Me.DrawingArea.TabIndex = 0
		Me.DrawingArea.Font = New System.Drawing.Font("Arial", 8!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
		Me.DrawingArea.Dock = System.Windows.Forms.DockStyle.None
		Me.DrawingArea.BackColor = System.Drawing.SystemColors.Control
		Me.DrawingArea.CausesValidation = True
		Me.DrawingArea.Enabled = True
		Me.DrawingArea.ForeColor = System.Drawing.SystemColors.ControlText
		Me.DrawingArea.Cursor = System.Windows.Forms.Cursors.Default
		Me.DrawingArea.RightToLeft = System.Windows.Forms.RightToLeft.No
		Me.DrawingArea.TabStop = True
		Me.DrawingArea.Visible = True
		Me.DrawingArea.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Normal
		Me.DrawingArea.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
		Me.DrawingArea.Name = "DrawingArea"
		Me.Controls.Add(ExitButton)
		Me.Controls.Add(DrawingArea)
	End Sub
#End Region 
#Region "Upgrade Support "
	Private Shared m_vb6FormDefInstance As MainForm
	Private Shared m_InitializingDefInstance As Boolean
	Public Shared Property DefInstance() As MainForm
		Get
			If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
				m_InitializingDefInstance = True
				m_vb6FormDefInstance = New MainForm()
				m_InitializingDefInstance = False
			End If
			DefInstance = m_vb6FormDefInstance
		End Get
		Set
			m_vb6FormDefInstance = Value
		End Set
	End Property
#End Region 
	'********************************************************************************
	'* VXPLib example
	'*
	'* Area Tooltip
	'*
    '* Last Modified on 22/12/2002
	'*
	'* This example is an intellectual property of Vitaly Tomilov
	'*********************************************************************************
	
	'This example illustrates how to attach a tooltip to any part of a visual element,
	'such as part of a window.
	'In this example we draw a cross in the middle of a picture box to have four quarters
	'in it, and then attach a different tooltip to each quarter.
	'
	'Note: When attaching tooltips this way the value of the TraceMode flag is always
    'ignored, and the tooltip gets hidden just as the mouse cursor moves.
	
    'Declaring an instance of a Tooltip Manager
    Private WithEvents manager As new VXPLibrary.VXPTooltipManager()

	Private Sub ExitButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ExitButton.Click
		'Unloading the form
		MainForm.DefInstance.Close()
	End Sub
	
	Private Sub DrawingArea_Paint(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.PaintEventArgs) Handles DrawingArea.Paint
		'Painting a cross in the middle of the picture box:
        Dim BlackPen As New Pen(Color.Black, 1)
        Dim HalfWidth As Integer
        Dim HalfHeight As Integer
        HalfWidth = eventArgs.ClipRectangle.Width / 2
        HalfHeight = eventArgs.ClipRectangle.Height / 2
        eventArgs.Graphics.DrawLine(blackPen, HalfWidth, eventArgs.ClipRectangle.Y, HalfWidth, eventArgs.ClipRectangle.Height)
        eventArgs.Graphics.DrawLine(blackPen, eventArgs.ClipRectangle.X, HalfHeight, eventArgs.ClipRectangle.Width, HalfHeight)
    End Sub

    Private Sub MainForm_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        'Adding two tooltips to the standard visual elements:
        manager.windows.Add(Handle.ToInt32, "<body bgcolor=lightsalmon><b>Area Tooltips</b><br>This example shows how to attach a tooltip<br>to an area within a window. For each drawn<br>quarter we can see a different tooltip.")
        manager.windows.Add(ExitButton.Handle.ToInt32, "<body bgcolor=palegreen>E<u>x</u>it the <i><font color=blue>Area Tooltip</font></i><br>application. <b>Alt+F4</b>")

        'Telling the Tooltip Manager to display tooltips just after
        'having been only 0.3 second over an object:
        manager.ShowDelay = 300

    End Sub

    'This is the key method, which is an event fired by the Tooltip Manager.
    'The event is fired for any window that doesn't have a tooltip attached to it,
    'and for which it is time to show a tooltip.
    'If an application wants to show a tooltip it has to set parameter Text to an html contents:
    Private Sub manager_OnActivateCustomTooltip(ByVal hWnd As Integer, ByVal ClassName As String, ByVal x As Short, ByVal y As Short, ByRef Text As String) Handles manager.OnActivateCustomTooltip
        Dim AtClause As String
        If hWnd = DrawingArea.Handle.ToInt32 Then 'If this is the window of our interest
            'Formatting extra information about mouse cursor position relative to the window:
            AtClause = "<br>x =<font color=blue weight=700>" & Str(x) & "</font>, y =<font color=blue weight=700>" & Str(y) & "</font>"
            With DrawingArea
                If x > .Width / 2 And y > .Height / 2 Then 'If right bottom quarter
                    Text = "<body bgcolor=gold><b>Quarter 4</b>" & AtClause
                Else
                    If x < .Width / 2 And y > .Height / 2 Then 'If left bottom quarter
                        Text = "<body bgcolor=pink><b>Quarter 3</b>" & AtClause
                    Else
                        If x < .Width / 2 And y < .Height / 2 Then 'If left top quarter
                            Text = "<body bgcolor=palegreen><b>Quarter 1</b>" + AtClause
                        Else 'Right top quarter
                            Text = "<body bgcolor=lightblue><b>Quarter 2</b>" & AtClause
                        End If
                    End If
                End If
            End With
        End If
    End Sub
End Class
