Option Strict Off
Option Explicit On
Friend Class MainForm
	Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
	Public Sub New()
		MyBase.New()
		If m_vb6FormDefInstance Is Nothing Then
			If m_InitializingDefInstance Then
				m_vb6FormDefInstance = Me
			Else
				Try 
					'For the start-up form, the first instance created is the default instance.
					If System.Reflection.Assembly.GetExecutingAssembly.EntryPoint.DeclaringType Is Me.GetType Then
						m_vb6FormDefInstance = Me
					End If
				Catch
				End Try
			End If
		End If
		'This call is required by the Windows Form Designer.
		InitializeComponent()
	End Sub
	'Form overrides dispose to clean up the component list.
	Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
		If Disposing Then
			If Not components Is Nothing Then
				components.Dispose()
			End If
		End If
		MyBase.Dispose(Disposing)
	End Sub
	'Required by the Windows Form Designer
	Private components As System.ComponentModel.IContainer
	Public ToolTip1 As System.Windows.Forms.ToolTip
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
	'Do not modify it using the code editor.
    Public WithEvents TextLabel As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.TextLabel = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'TextLabel
        '
        Me.TextLabel.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left)
        Me.TextLabel.BackColor = System.Drawing.SystemColors.Control
        Me.TextLabel.Cursor = System.Windows.Forms.Cursors.Default
        Me.TextLabel.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TextLabel.ForeColor = System.Drawing.SystemColors.ControlText
        Me.TextLabel.Name = "TextLabel"
        Me.TextLabel.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.TextLabel.Size = New System.Drawing.Size(312, 194)
        Me.TextLabel.TabIndex = 0
        Me.TextLabel.Text = "Hold still the mouse cursor over this form for just a moment to cause the tooltip" & _
        " to appear."
        Me.TextLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(312, 190)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.TextLabel})
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Location = New System.Drawing.Point(4, 30)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "VXPLib - <DOC> tag example"
        Me.ResumeLayout(False)

    End Sub
#End Region 
#Region "Upgrade Support "
	Private Shared m_vb6FormDefInstance As MainForm
	Private Shared m_InitializingDefInstance As Boolean
	Public Shared Property DefInstance() As MainForm
		Get
			If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
				m_InitializingDefInstance = True
				m_vb6FormDefInstance = New MainForm()
				m_InitializingDefInstance = False
			End If
			DefInstance = m_vb6FormDefInstance
		End Get
		Set
			m_vb6FormDefInstance = Value
		End Set
	End Property
#End Region 
	'*************************************************************
	'* VXPLib example
	'*
	'* Using tag <doc> - virtual document
	'*
    '* Last Modified on 22/12/2002
	'*
	'* This example is an intellectual property of Vitaly Tomilov
	'*************************************************************
	
	'This example illustrates the use of virtual documents through tag <doc>.
	'All parameters and functionality of this tag are explained in the QHTML specification.
	'Run this example, and hover the mouse cursor over the main window to bring up the
	'only tooltip managed in this application.
	
    Private WithEvents manager As New VXPLibrary.VXPTooltipManager()

    'Note: Global variable html was declared because this is the only way to make
    'VB see the list of events that can be handled for this particular interface
    Private WithEvents html As VXPLibrary.VXPQuickHTML = manager.tool.html

    Private Sub MainForm_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        With manager
            'Adding a tooltip and attaching it to the main window of the application
            'Note: the key element in the string for this example is '<doc bgcolor=red border=2 bordercolor=lightgreen>'
            .windows.Add(TextLabel.Handle.ToInt32, "<body bgcolor=darkblue><font color=white>This example illustrates a virtual document" & "<br>that draws its contents as a simple circle<br>with two criss-crossed lines:</font><br><table><tr><td>" & "<doc bgcolor=red border=2 bordercolor=lightgreen></td><td align=center valign=middle><font color=yellow>" & "You can draw a document<br>of any complexity</td></tr></table>")
            .tool.BorderColor = System.Convert.ToUInt32(RGB(255, 0, 0)) 'Setting red color for the tooltip border
            .tool.FadeHide = 2000 'The tooltip must fade away within 2 seconds
            .tool.FadeShow = 2000 'The tooltip must appear completely within 2 seconds
            .ShowDelay = 100 'The tooltip must be shown after being just 0.1 second over the object
        End With
    End Sub

    'Because we do not specify Width and Height right in the tag we have to set them to a value
    'different from 0 inside this event handler. If we do not do this, the document tag will be
    'ignored and the document won't be drawn (OnDocumentDraw won't be called).
    'Alternative to handling this event would be specifying attributes WIDTH and HEIGHT right in the <DOC> tag.
    Private Sub html_OnDocumentGetSize(ByVal DocumentPath As String, ByVal Param As String, ByRef W As Short, ByRef H As Short) Handles html.OnDocumentGetSize

        W = 80
        H = 80

    End Sub

    ' Note: It is responsibility of the developer not to draw anything outside
    ' rectangle {X, Y, X + Width, Y + Height}. All drawing coordinates in this
    ' example are used with this in view. And it is the only reason why {X, Y} are
    ' also passed as parameters.
    Private Sub html_OnDocumentDraw(ByVal DocumentPath As String, ByVal Param As String, ByVal DC As Integer, ByVal X As Short, ByVal Y As Short, ByVal W As Short, ByVal H As Short) Handles html.OnDocumentDraw

        Dim draw As Graphics = Graphics.FromHdc(IntPtr.op_Explicit(DC))
        Dim BlackPen As New Pen(Color.Black, 1)
        Dim WhiteBrush As New SolidBrush(Color.White)
        'In this example we just draw a simple picture to give developers an idea of how
        'drawing can be done:
        draw.FillEllipse(WhiteBrush, X, Y, W, H)
        draw.DrawEllipse(BlackPen, X, Y, W, H)
        draw.DrawLine(BlackPen, X + 12, Y + 12, X + 68, Y + 68)
        draw.DrawLine(BlackPen, X + 68, Y + 12, X + 12, Y + 68)
    End Sub

End Class
